#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>

#include <glib.h>
#include <slang/slang.h>

GMainLoop *mainLoop;
GMainContext *mainContext;


#define KEY_M_CTRL  0x4000
#define XCTRL(x) (KEY_M_CTRL | ((x) & 31))

static
gboolean tty_callback_handler  (GIOChannel *source, GIOCondition condition, gpointer data)
{
    int c;
    printf("enter\n");

    switch (condition){
    case G_IO_IN:
	while (SLang_input_pending (0) ){
	    c = SLang_getkey();
	    printf("! readed: %d, key %c\r\n", c, c);
	}

    break;
    case G_IO_HUP:
	printf("G_IO_HUP\n");
    break;
    case G_IO_PRI:
	printf("G_IO_PRI\n");
    break;
    case G_IO_ERR:
	printf("G_IO_ERR\n");
    break;
    case G_IO_NVAL:
	printf("G_IO_NVAL\n");
    break;
    default:
	printf("UNKNOWN!!!\n");
	return FALSE;
    break;
    }
    return TRUE;
}

static gboolean open_tty (void){
    GPid tty_pid;

    GIOChannel *tty_channel;

    tty_pid = SLang_TT_Read_FD;

    if (tty_pid == -1)
	return FALSE;

    tty_channel = g_io_channel_unix_new (tty_pid);
    g_io_channel_set_encoding (tty_channel, NULL, NULL);

    g_io_add_watch (tty_channel, G_IO_IN|G_IO_HUP|G_IO_PRI|G_IO_ERR|G_IO_NVAL , tty_callback_handler, NULL);
    g_io_channel_set_buffered (tty_channel, FALSE);


    return TRUE;
}



int main (void)
{
    SLang_init_tty (XCTRL('c'), 1, 0);

    mainLoop = g_main_loop_new (NULL, FALSE);

    mainContext =  g_main_context_default ();

    if (! open_tty ()){
	g_main_loop_unref (mainLoop);
	return 1;
    }

    g_main_loop_run (mainLoop);
    g_main_loop_unref (mainLoop);
    return 0;
}
